=== debian/changelog ===
sleef (3.5.1-3) unstable; urgency=medium

  * Team upload.
  * Fix build with latest mpfr (Closes: #1030432)
  * d/tests/control: specify arch to amd64 only

 -- Aron Xu <aron@debian.org>  Wed, 08 Feb 2023 14:10:11 +0800

sleef (3.5.1-2) unstable; urgency=medium

  * Switch to Clang as CC and CXX (Closes: #1013040)
    Upstream support to the latest gcc (GCC-12) is limited.
  * Refresh symbols control file for ppc64el.
  * Only track C++ symbols for amd64 architecture.

 -- Mo Zhou <lumin@debian.org>  Fri, 30 Sep 2022 15:18:34 -0400

sleef (3.5.1-1) unstable; urgency=medium

  * New upstream version 3.5.1
  * Mark autopkgtest as skippable and return 77 for !amd64. (Closes: #970566)
  * Refresh symbols list for amd64, arm64 and armhf.

 -- Mo Zhou <lumin@debian.org>  Thu, 29 Oct 2020 10:13:59 +0800
