=== debian/tests/control ===
Test-Command: if test $(dpkg --print-architecture) = 'amd64'; then true; else exit 77; fi;
 gcc doc/html/hellox86.c -lsleef -o hellox86; ./hellox86;
Depends: @, build-essential,
Restrictions: skippable
Architecture: amd64
